/* 2006-11-18 programmeerimisvistlus                                       */
/* lesanne: SIDEKAABLITE REMONT                                            */
/* Autor: Margus Niitsoo                                                    */
/* Testitud: GCC 3.2.3 / MinGW32                                            */

/* Natuke ebaefektiivne lahendus */
/* Kasutab laiuti lbimist ja hoiab graafi naabrusmaatriksina */

#include <stdio.h>

int adj[1001][1001]; // Naabrusnimistu
int q[1001]; // Jrjend BFS tarbeks
char noted[1001];

int main()
{
    int n, m;
    int a, b;
    int i, k, l, nd;
    int res=0;
    FILE *in, *out;

    in=fopen("side.sis","rt");
    fscanf(in,"%i %i",&n,&m);

    for(i=0;i<n;i++)
        for(k=0;k<n;k++)
            adj[i][k]=0;

    for(i=0;i<m;i++)
    {
        fscanf(in,"%i %i",&a,&b);
        a--; b--; // Indeksid 1...n kujult 0...(n-1) kujule
        adj[a][b]++; adj[b][a]++; 
    }

    fclose(in);

    for(a=0;a<n;a++)
        for(b=a;b<n;b++)
            if(adj[a][b]) // Vaatame igat serva vaid htepidi
            {
                // Eemaldame serva ja kontrollime graafi sidusust
                adj[a][b]--; adj[b][a]--;

                // Mrgime kik tipud mitteklastatuks
                for(i=0;i<n;i++) noted[i]=0;

                // Laiuti otsing ehk BFS
                q[0]=a; noted[a]=1; i=0; k=1;
                while(i<k)
                {
                    nd=q[i];

                    if(nd==b) break; // Lpetame, kui leidsime tee a->b

                    for(l=0;l<n;l++)
                        if(adj[nd][l] && noted[l]==0)
                        {
                            q[k]=l; noted[l]=1; k++;
                        }

                    i++;
                }

                if(nd!=b && i==k) // BFS ei judnud al[a][b]-sse
                    res++;

                adj[a][b]++; adj[b][a]++;
            }

    out=fopen("side.val","wt");
    fprintf(out,"%i\n",res);
    fclose(out);

    return 0;
}
