{ 2006-11-18 programmeerimisvistlus                                        }
{ lesanne: SUDOKU                                                          }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

{ Kitsendab enne lbivaatust valikuvariantide hulka paljudes ruutudes       }
{ NB! Loeb standardsisendist, kirjutab standardvljundisse                  }

const
   blkr = 3;                                         { bloki krgus ridades }
   blkv = 5;                                        { bloki laius veergudes }
   blkm = blkr * blkv;      { bloki suurus mrkides, ka ridade/veergude arv }
   tmin = 'A'; tmax = 'O';                             { kasutatavad mrgid }
   tuhik = '.';

{ variantide kitsendamise osa }

type
   hulk = set of 1..blkm;                                  { indeksite hulk }

var
   x : array [1..blkm, 1..blkm] of hulk;    { vlistamata variantide hulgad }

{ teisendab mrgi heelemendiliseks hulgaks }
function hulgaks(c : char) : hulk;
begin
   exit([ord(c) - ord(tmin) + 1]);
end;

{ teisendab heelemendilise hulga mrgiks }
function margiks(h : hulk) : char;
var i : integer;
begin
   for i := 1 to blkm do
      if [i] = h then
         exit(chr(ord(tmin) + i - 1));
   exit('.');
end;

{ leiab hulga suuruse (elementide arvu) }
function elemente(h : hulk) : integer;
var n, i : integer;
begin
   n := 0;
   for i := 1 to blkm do
      if i in h then
         n := n + 1;
   exit(n);
end;

{ teisendab antud hulga talle leksikograafiliselt jrgnevaks }
function jargmine(var h : hulk) : boolean;
var i : integer;
begin
   for i := 1 to blkm do
      if i in h then begin
         h := h - [i];
      end else begin
         h := h + [i];
         exit(true);
      end;
   exit(false);
end;

{ kitsendab antud bloki ruutude variantide hulki }
function kitsenda(r1, v1, r2, v2 : integer) : boolean;
var h1, h2 : hulk; i, ir, iv : integer;
begin
   assert((r2 - r1 + 1) * (v2 - v1 + 1) = blkm);
   kitsenda := false;                     { seni pole nnestunud kitsendada }
   { vaatame bloki ruutude hulkade mittethje alamhulki }
   h1 := [];
   while jargmine(h1) do begin
      { leiame valitud ruutude kandidaatide hulkade hendi }
      h2 := [];
      for i := 1 to blkm do
         if i in h1 then begin
            ir := r1 + (i - 1) div (v2 - v1 + 1);
            iv := v1 + (i - 1) mod (v2 - v1 + 1);
            h2 := h2 + x[ir, iv];
         end;
      { kui kandidaatide arv on tpselt ruutude arv... }
      if elemente(h1) = elemente(h2) then
         { ...siis ei saa need enam teiste ruutude kandidaadid olla }
         for i := 1 to blkm do
            if not (i in h1) then begin
               ir := r1 + (i - 1) div (v2 - v1 + 1);
               iv := v1 + (i - 1) mod (v2 - v1 + 1);
               { kui mni kandidaat seni veel oli ka mujal kandidaat }
               if x[ir, iv] * h2 <> [] then begin
                  kitsenda := true;         { siis on nnestunud kitsendada }
                  x[ir, iv] := x[ir, iv] - h2;
               end;
            end;
   end;
end;

{ variantide lbivaatuse osa }

var
   a : array [1..blkm, 1..blkm] of char;                             { laud }
   vr : array [1..blkm, tmin..tmax] of boolean;      { vabad mrgid ridades }
   vv : array [1..blkm, tmin..tmax] of boolean;             { ... veergudes }
   vb : array [1..blkv, 1..blkr, tmin..tmax] of boolean;    { ... blokkides }

{ kas kohale [r,v] vib panna mrgi m }
function vaba(r, v : integer; m : char) : boolean;
begin
   vaba := vr[r, m] and vv[v, m] and
      vb[(r - 1) div blkr + 1, (v - 1) div blkv + 1, m];
end;

{ paneb mrgi m kohale [r,v] }
procedure pane(r, v : integer; m : char);
begin
   a[r, v] := m;
   vr[r, m] := false;
   vv[v, m] := false;
   vb[(r - 1) div blkr + 1, (v - 1) div blkv + 1, m] := false;
end;

{ eemaldab mrgi m kohalt [r,v] }
procedure vota(r, v : integer; m : char);
begin
   a[r, v] := tuhik;
   vr[r, m] := true;
   vv[v, m] := true;
   vb[(r - 1) div blkr + 1, (v - 1) div blkv + 1, m] := true;
end;

{ otsib variante panna mrki kohale [r,v] }
procedure otsi(r, v : integer);
var c : char;
begin
   if r > blkm then begin
      for r := 1 to blkm do begin
         for v := 1 to blkm do
            write(a[r, v]);
         writeln;
      end;
      halt(0);                              { kui hest lahendist piisab... }
   end else if v > blkm then begin
      otsi(r + 1, 1);
   end else begin
      for c := tmin to tmax do
         if (ord(c) - ord(tmin) + 1) in x[r, v] then
            if vaba(r, v, c) then begin
               pane(r, v, c);
               otsi(r, v + 1);
               vota(r, v, c);
            end;
   end;
end;

{ phiprogramm }

var i, j : integer; c : char; v : boolean;
begin
   assert(ord(tmax) - ord(tmin) + 1 = blkm);
   { loeme sisendi ja mrame esialgsed kandidaatide hulgad }
   for i := 1 to blkm do begin
      for j := 1 to blkm do begin
         read(c);
         if c = tuhik then
            x[i, j] := [1..blkm]
         else
            x[i, j] := hulgaks(c);
      end;
      readln;
   end;
   { kitsendame kandidaatide hulgad }
   repeat
      v := false;                       { esialgu pole kski hulk vhenenud }
      for i := 1 to blkm do
         if kitsenda(i, 1, i, blkm) then
            v := true;
      for j := 1 to blkm do
         if kitsenda(1, j, blkm, j) then
            v := true;
      for i := 1 to blkv do
         for j := 1 to blkr do
            if kitsenda((i - 1) * blkr + 1, (j - 1) * blkv + 1, i * blkr, j * blkv) then
               v := true;
   until not v;
   { algseis: kik on vabad }
   for i := 1 to blkm do
      for c := tmin to tmax do begin
         vr[i, c] := true;
         vv[i, c] := true;
      end;
   for i := 1 to blkv do
      for j := 1 to blkr do
         for c := tmin to tmax do
            vb[i, j, c] := true;
   { alustame variantide lbivaatust vasakult levalt }
   otsi(1, 1);
end.
